<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="100px"
    >
      <el-row>
<!--        <el-form-item label="锁定站编码" prop="lotoCode">-->
<!--          <el-input-->
<!--            v-model="queryParams.lotoCode"-->
<!--            placeholder="请输入锁定站编码"-->
<!--            clearable-->
<!--            @lotoup.enter.native="handleQuery"-->
<!--          />-->
<!--        </el-form-item>-->

        <el-form-item label="锁定站名称" prop="lotoName">
          <el-input
            v-model="queryParams.lotoName"
            placeholder="请输入锁定站名称"
            clearable
            @lotoup.enter.native="handleQuery"
          />
        </el-form-item>

        <el-form-item label="岗位" prop="workstationId" >
          <treeselect style="width: 200px" v-model="queryParams.workstationId" :options="marsOptions" :normalizer="Marsnormalizer" placeholder="请选择岗位"/>
        </el-form-item>
        <el-form-item label="设备/工艺" prop="lotoId" >
          <treeselect style="width: 200px" v-model="queryParams.lotoId" :options="machineryOptions" :normalizer="Machinerynormalizer" placeholder="请选择设备/工艺"/>
        </el-form-item>
        <el-form-item style="margin-left: 20px">
          <el-button v-no-more-click
                     type="primary"
                     icon="el-icon-search"
                     size="mini"
                     @click="handleQuery"
          >搜索
          </el-button>
          <el-button v-no-more-click icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置
          </el-button>
        </el-form-item>
      </el-row>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button v-no-more-click
                   type="primary"
                   plain
                   icon="el-icon-plus"
                   size="mini"
                   @click="handleAdd"
                   v-hasPermi="['iscs:station:add']"
        >新增
        </el-button>
      </el-col>

      <el-col :span="1.5">
        <el-button v-no-more-click
                   type="danger"
                   plain
                   icon="el-icon-delete"
                   size="mini"
                   :disabled="multiple"
                   @click="handleDelete"
                   v-hasPermi="['iscs:station:remove']"
        >批量删除
        </el-button>
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="repairList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
<!--      <el-table-column-->
<!--        label="锁定站编码"-->
<!--        width="150px"-->
<!--        align="center"-->
<!--        prop="lotoCode"-->
<!--      />-->
      <el-table-column
        label="锁定站名称"
        width="180px"
        align="center"
        prop="lotoName"
      />
      <el-table-column
        label="排序"
        width="180px"
        align="center"
        prop="orderNum"
      />
      <el-table-column label="岗位" align="center" prop="workstationName" />

      <el-table-column
        label="锁定站详情"
        align="center"
        prop="create"
        width="200"
      >
        <template slot-scope="scope">
          <el-button
            v-no-more-click
            size="mini"
            type="text"
            @click="look(scope.row)"
          >查看
          </el-button>
        </template>
      </el-table-column>
<!--      <el-table-column-->
<!--        label="创建时间"-->
<!--        align="center"-->
<!--        prop="createTime"-->
<!--        width="180"-->
<!--      >-->
<!--        <template slot-scope="scope">-->
<!--          <span>{{ scope.row.createTime }}</span>-->
<!--        </template>-->
<!--      </el-table-column>-->

      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button v-no-more-click
                     size="mini"
                     type="text"
                     icon="el-icon-edit"
                     @click="handleUpdate(scope.row)"
                     v-hasPermi="['iscs:station:edit','iscs:station:query']"
          >修改
          </el-button>
          <el-button v-no-more-click
                     size="mini"
                     type="text"
                     icon="el-icon-delete"
                     @click="handleDelete(scope.row)"
                     v-hasPermi="['iscs:station:remove']"
          >删除
          </el-button>
          <!--          <el-button v-no-more-click size="mini" type="text">预览</el-button>-->
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.current"
      :limit.sync="queryParams.size"
      @pagination="getList"
    />

    <!-- 添加或修改设备维修单对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="450px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="锁定站名称" prop="lotoName">
          <el-input v-model="form.lotoName" placeholder="请输入锁定站名称" />
        </el-form-item>
<!--        <el-row>-->
<!--          <el-col :span="15">-->
<!--            <el-form-item label="锁定站编码" prop="lotoCode">-->
<!--              <el-input-->
<!--                v-model="form.lotoCode"-->
<!--                placeholder="请输入锁定站编码"-->
<!--                style="width: 100%"-->
<!--              />-->
<!--            </el-form-item>-->
<!--          </el-col>-->
<!--          <el-col :span="8">-->
<!--            <el-form-item label-width="80">-->
<!--              <el-switch-->
<!--                v-model="autoGenFlag"-->
<!--                active-color="#13ce66"-->
<!--                active-text="自动生成"-->
<!--                @change="handleAutoGenChange(autoGenFlag)"-->
<!--              >-->
<!--              </el-switch>-->
<!--            </el-form-item>-->
<!--          </el-col>-->
<!--        </el-row>-->
        <el-form-item label="排序" prop="orderNum">
          <el-input-number type="number" v-model="form.orderNum" />
        </el-form-item>
        <el-form-item label="岗位" prop="workstationId" >
          <treeselect v-model="form.workstationId" :options="marsOptions" :normalizer="Marsnormalizer" placeholder="选择岗位"/>
        </el-form-item>

        <el-form-item label="锁定站信息" prop="map">
          <el-input
            v-model="form.map"
            placeholder="请输入锁定站信息"

          />
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button v-no-more-click type="primary" @click="submitForm">确 定</el-button>
        <el-button v-no-more-click @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listLoto,
  getLotoInfo,
  addLoto,
  updateLoto,
  delLoto
} from "@/api/mes/lotoStation/lotoStation";
import { genCode } from "@/api/system/autocode/rule";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import { listMarsDept } from '@/api/system/marsdept'
import { listTechnology } from '@/api/system/machinery'
export default {
  name: "lock",
  dicts: ["hardware_status"],
  components: { Treeselect },
  data() {
    return {
      autoGenFlag: false,
      optType: undefined,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      codes: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // mars树选项
      marsOptions: [],
      // 总条数
      total: 0,
      // 设备维修单表格数据
      repairList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      createTime: "",
      queryParams: {
        current: 1,
        size: 10,
        lotoCode: null,
        lotoName: null,

      },
      // 表单参数
      form: {
      },
      // 表单校验
      rules: {
        lotoCode: [
          { required: true, message: "锁定站编码不能为空", trigger: "blur" },
        ],
        lotoName: [
          { required: true, message: "锁定站名称不能为空", trigger: "blur" },
        ],
      },
      // 日期选择
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
      EditId: 0, //修改判断
      machinerytypeOptions: [], //锁具机构类型
      machineryOptions:[],//查询 设备工艺数据
    };
  },
  created() {
    this.getList();
    this.getOtherList()
  },
  methods: {

    //自动生成编码
    handleAutoGenChange(autoGenFlag) {
      if (autoGenFlag) {
        genCode("LOTO_STATION_CODE").then((response) => {
          this.form.lotoCode = response;
        });
      } else {
        this.form.lotoCode = null;
      }
    },
    /** 查询设备维修单列表 */

    getList() {
      this.loading = true;

      // 锁定站数据
      listLoto(this.queryParams).then((response) => {
        console.log(response,'锁定站')
        this.repairList = response.data.records;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    getOtherList(){
      const data={
        pasge:1,
        size:-1
      }
      listMarsDept(data).then(response => {
        this.marsOptions = this.handleTree(response.data.records,"workstationId","parentId")
      })

      // 设备/工艺
      listTechnology(data).then((response) => {
        const data=response.data.records.filter((item) =>item.machineryType=='工艺')
        this.machineryOptions = this.handleTree(
          data,
          "machineryId",
          "parentId"
        );

      });
    },
    /** 转换部门数据结构 */
    Marsnormalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children
      }
      return {
        id: node.workstationId,
        label: node.workstationName,
        children: node.children
      }
    },
    // 设备工艺树
    Machinerynormalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children
      }
      return {
        id: node.lotoId,
        label: node.machineryName,
        children: node.children
      }
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        lotoName: null,
        workstationId: null,
        orderNum: null,
        map:null
      };

      this.autoGenFlag = false;
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.current = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.queryParams.lotoName = "";
      this.queryParams.lotoId = "";
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.lotoId);
      this.codes = selection.map((item) => item.lotoName);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.EditId = null;
      this.title = "新增锁定站信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.EditId = row.lotoId || this.ids;
      getLotoInfo(this.EditId).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改锁定站信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.EditId != null) {
            updateLoto(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            // console.log(this.form, "form");
            addLoto(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.EditId = null;
              this.getList();
            });
          }
        }
      });
    },
    // 地图预览
    look(row) {
      console.log(row, "row预览");
      const data = row.lotoId;
      this.$router.push(`/mes/hw/lotoStation/index/MapData?lotoId=${data}`);
      // this.dialogVisibleMap = true; // 显示地图预览弹框
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const repairIds = row.lotoId || this.ids;
      const repairCodes = row.lotoName || this.codes;
      this.$modal
        .confirm('是否确认删除所选数据项？')
        .then(function () {
          return delLoto(repairIds);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
  },
};
</script>
<style scoped>
.imgstatus {
  position: relative;
  top: 1px;
  left: 0px;
}

/deep/ .el-radio__inner {
  border-radius: 2px;
}

/deep/ .el-radio__input.is-checked .el-radio__inner::after {
  content: "";
  width: 8px;
  height: 3px;
  border: 1px solid white;
  border-top: transparent;
  border-right: transparent;
  text-align: center;
  display: block;
  position: absolute;
  top: 3px;
  left: 2px;
  transform: rotate(-45deg);
  border-radius: 0pc;
  background: none;
}
</style>
